"""Copyright 2014 Cooper Willis

This file is part of Not Alone.

    Not Alone is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Not Alone is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Not Alone.  If not, see <http://www.gnu.org/licenses/>.

"""


import pygame
from sys import exit
from pygame.locals import *
from lib.vector import *
import pickle
from lib.collisions import check_creeps, check_enemies

WIDTH = 640
HEIGHT = 480

SCREEN = pygame.display.set_mode((WIDTH,HEIGHT),0,32)
pygame.display.set_caption("Not Alone")

pygame.init()
clock = pygame.time.Clock()

def main():
	SPOTLIGHT = Vector(20,20)
	SPOTLIGHT_SPEED = 5
	SPOTLIGHT_RADIUS = 20
	dest_x = SPOTLIGHT.x
	dest_y = SPOTLIGHT.y
	heading = Vector()
	distance_vector = Vector()
	FLASHLIGHT = 0
	PLAYER = Player(400,400,3,10,0,0,20)
	lightdark = pygame.image.load("images/lightdark_t.png").convert_alpha()
	fast = pygame.image.load("images/fast.png").convert_alpha()
	exitim = pygame.image.load("images/exitimage.png").convert_alpha()
	CREEP = Creep(200,200, fast,False)
	CREEPLIST = {}
	BGLIST = {}
	EXITLIST = {} 
	PLAYER_START = {}

	while True:
		clock.tick(30)
		safe = True
		for event in pygame.event.get():
			if event.type == QUIT:
				exit()
			elif event.type == MOUSEBUTTONUP:
				dest_x, dest_y = pygame.mouse.get_pos()
				if len(CREEPLIST) == 0:
					CREEPLIST[(dest_x,dest_y)]=Creep(dest_x, dest_y, fast, False)
				else:
					temp_creep = Creep(dest_x, dest_y, fast, False)
					for key, CREEP in CREEPLIST.iteritems():
						if check_creeps(temp_creep, CREEP,10):
							del CREEPLIST[key]
							safe = False
							break
					if safe:
						CREEPLIST[(dest_x,dest_y)]=Creep(dest_x, dest_y, fast, False)
			elif event.type == KEYDOWN:
				if event.key == K_s:
					fname = raw_input("enter filename>> ")
					saved = open( 'maps/' + fname + '.pkl', 'wb')
					save_list = [CREEPLIST,BGLIST,EXITLIST,PLAYER_START]
					pickle.dump(save_list, saved)
				if event.key == K_b:
					dest_x, dest_y = pygame.mouse.get_pos()
					if len(BGLIST) == 0:
						BGLIST[(dest_x,dest_y)]=BigCreep(dest_x, dest_y, lightdark)
					else:
						temp_creep = BigCreep(dest_x, dest_y, fast)
						for key, BIGCREEP in BGLIST.iteritems():
							if check_creeps(temp_creep, BIGCREEP,20):
								del BGLIST[key]
								safe = False
								break
						if safe:
							BGLIST[(dest_x,dest_y)]=BigCreep(dest_x, dest_y, lightdark)
				if event.key == K_e:
					dest_x, dest_y = pygame.mouse.get_pos()
					if len(EXITLIST) == 0:
						EXITLIST[(dest_x,dest_y)]=Exit(dest_x, dest_y, exitim, False)
					else:
						temp_ex = Exit(dest_x, dest_y, exitim, False)
						for key, ex in EXITLIST.iteritems():
							if check_creeps(temp_ex, ex,20):
								del EXITLIST[key]
								safe = False
								break
						if safe:
							EXITLIST[(dest_x,dest_y)]=Exit(dest_x, dest_y, exitim, False)
				if event.key == K_p:
					dest_x, dest_y = pygame.mouse.get_pos()
					if len(PLAYER_START) == 0:
						PLAYER_START[(dest_x,dest_y)]=Player(dest_x, dest_y,2,500,0,0,20)
					else:
						temp_player = Player(dest_x, dest_y,2,500,0,0,20)
						for key, player in PLAYER_START.iteritems():
							if check_enemies(temp_player,player):
								del PLAYER_START[key]
								safe = False
								break
						if safe:
							PLAYER_START[(dest_x,dest_y)]=Player(dest_x, dest_y,2,500,0,0,20)
						

		###	
		
		###
		SCREEN.fill((255,255,255))
		for CREEP in CREEPLIST.itervalues():
			SCREEN.blit(fast,(CREEP.position.x - CREEP.width/2,CREEP.position.y - CREEP.height/2))
		for BIGCREEP in BGLIST.itervalues():
			SCREEN.blit(lightdark,(BIGCREEP.position.x - BIGCREEP.width/2,BIGCREEP.position.y - BIGCREEP.height/2))
		for EXIT in EXITLIST.itervalues():
			SCREEN.blit(exitim,(EXIT.position.x - EXIT.width/2,EXIT.position.y - EXIT.height/2))
		for PLAYER in PLAYER_START.itervalues():
			pygame.draw.arc(SCREEN,(0,0,0),(int(PLAYER.position.x) - 10,int(PLAYER.position.y) + 10, 20, 20),(PLAYER.angle*math.pi/180.0 + 45*math.pi/180.0),(PLAYER.angle*math.pi/180.0 + 135*math.pi/180.0),10)
		pygame.display.update()
		
main()